package com.hd.live.wallpapers.page;


import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.paging.PagingSource;
import androidx.paging.PagingState;

import com.hd.live.wallpapers.bean.ResultData;
import com.hd.live.wallpapers.others.DbUtils;

import java.util.List;

import kotlin.coroutines.Continuation;

public class MyPageSource extends PagingSource<Integer, ResultData> {
     public static int pageSize = 20;
    private int wallpaperType;

    public MyPageSource(int wallpaperType) {
        this.wallpaperType = wallpaperType;
    }

    @Nullable
    @Override
    public Integer getRefreshKey(@NonNull PagingState<Integer, ResultData> pagingState) {
        return null;
    }

    @Nullable
    @Override
    public Object load(@NonNull LoadParams<Integer> loadParams, @NonNull Continuation<? super LoadResult<Integer, ResultData>> continuation) {

        try {
            int page = loadParams.getKey() != null ? loadParams.getKey() : 1;

            List<ResultData> data = DbUtils.queryData(wallpaperType,page);
//            Common.logMsg("-----load---------"+wallpaperType+"----page="+page+"'--data="+data.size());
            return new LoadResult.Page<>(
                    data,
                    page > 1 ? page - 1 : null,
                    data.isEmpty() ? null : page + 1
            );
        } catch (Exception e) {
            return new LoadResult.Error<>(e);
        }
    }
}

